00100 	TITLE	SYMMETRY by Robert Gault 1993
00110 
00120 RND	EQU	$116	LOCATION OF BASIC RANDOM NUMBER
00130 SCREEN	EQU	$2000	START OF HIGH RES. GRAPHICS SCREEN
00140 ENDSCR	EQU	$97FF	END OF HSCREEN2
00150 HSIZE	EQU	160	BYTES/HORIZONTAL ROW
00160 HCENTR	EQU	160	MIDDLE X VALUE; SCREEN VALUES
00170 YCENTR	EQU	96	MIDDLE Y VALUE
00180 HFCOLR	EQU	$FE0A	FOREGROUND COLOR
00190 TASK1	EQU	$E119	PUTS GRAPHICS BLOCKS IN MEMORY
00200 TASK0	EQU	$E0FF	PUTS SYSTEM BLOCKS IN MEMORY
00210 
00220 	ORG	$E00
00230 
00240 * NEXT VARIABLES CONTROLS SHAPE OF RANDOM PATTERN
00250 WALK	RMB	2	VALUE POKED FROM BASIC
00260 CLTIME	RMB	1	COLOR CHANGE TIME
00270 BACKUP	RMB	1
00280 
00290 START	JSR	TASK1	SETUP GRAPHICS MEMORY AND KILL IRQS
00300 	CLR	$FF02	SET KEYBOARD FOR ANY KEY
00310 
00320 MAIN	LDY	#700	DO 700 REPEATS PER RUN
00330 	CLRA		INITIALIZE VARIABLES
00340 	CLRB
00350 	STD	XLOC	CLEAR X&Y LOCATIONS
00360 	STA	CNTCLR	CLEAR COLOR SWAP COUNTER
00370 	BSR	CLRSCR	CLEAR THE SCREEN
00380 
00390 * MAIN PROGRAM LOOP FOR A SINGLE GRAPHICS SCREEN
00400 MLOOP	TST	CNTCLR	TIME TO CHANGE COLOR?
00410 	BNE	M2	BRANCH IF NOT
00420 
00430 	LDB	CLTIME	SWITCH COLOR ON VALUE POKED FROM BASIC
00440 	LBSR	RAND	GET A RANDOM COLOR PERIOD
00450 	INCA		REG.A NOW IS 1 - N
00460 	STA	CNTCLR	SET COUNTER
00470 	BSR	COLOR	SET A NEW COLOR
00480 
00490 M2	DEC	CNTCLR	UPDATE COUNT
00500 
00510 	LDB	XLOC	GET CURRENT X VALUE AND ADD A DELTA
00520 	LBSR	GETVAL	GET A NEW RANDOM DELTA
00530 	STB	XLOC	UPDATE X
00540 
00550 	LDB	YLOC	GET CURRENT Y VALUE AND ADD A DELTA
00560 	LBSR	GETVAL	"	"
00570 	STB	YLOC	"	"
00580 
00590 	LDA	XLOC	RECOVER X VALUE
00600 	BSR	POINT	PLOT USING SYMETRY
00610 	EXG	A,B	MIRROR AROUND X & Y
00620 	BSR	POINT
00630 
00640 	LEAY	-1,Y	FINISHED WITH THIS SCREEN YET?
00650 	BNE	MLOOP
00660 
00670 	BSR	KEYTST
00680 	BNE	EXIT	EXIT IF A KEY WAS PRESSED
00690 
00700 	LDB	#5	GIVE VIEWER A CHANCE TO SEE FINISHED SCREEN
00710 WAIT	LDX	#0
00720 WAIT2	LEAX	-1,X
00730 	BNE	WAIT2
00740 	BSR	KEYTST	CHECK FOR KEY PRESS AGAIN
00750 	BNE	EXIT
00760 	DECB
00770 	BNE	WAIT
00780 	BRA	MAIN
00790 
00800 EXIT	JSR	TASK0	RETURN SYSTEM MEMORY START IRQS
00810 	RTS		RETURN TO BASIC
00820 
00830 KEYTST	LDA	$FF00	SEE IF ANY KEYS WERE PRESSED
00840 	COMA
00850 	RTS
00860 
00870 * ENTER: REG.D = 0
00880 CLRSCR	LDX	#SCREEN		CLEAR GRAPHICS SCREEN
00890 CLOOP	STD	,X++
00900 	CMPX	#ENDSCR
00910 	BLS	CLOOP
00920 	RTS
00930 
00940 COLOR	LDB	#15
00950 	BSR	RAND	RANDOM PALETTE 0 - 14
00960 	INCA		RND PALETTE 1 - 15
00970 	STA	HFCOLR	SAVE PALETTE NUMBER OF FOREGROUND
00980 	RTS
00990 
01000 * ENTER REG.A=X, REG.B=Y
01010 * EXIT  REG. A&B INTACT
01020 POINT	PSHS	D	+X+Y
01030 	BSR	HPOINT
01040 	NEGB		+X-Y
01050 	BSR	HPOINT
01060 	NEGA		-X-Y
01070 	BSR	HPOINT
01080 	NEGB		-X+Y
01090 	BSR	HPOINT
01100 	PULS	D,PC
01110 
01120 * ENTER: REG.A= MODIFIED X, REG.B=MODIFIED Y
01130 * EXIT:  REG A & B INTACT
01140 HPOINT	PSHS	D	A=X B=Y
01150 	ADDA	#HCENTR		CONVERT FROM CENTER TO CORNER RELATIVE
01160 	ADDB	#YCENTR
01170 	LSRA			2 PIXELS PER BYTE
01180 	PSHS	CC,A		SAVE VALUE AND WHETHER ODD OR EVEN PIXEL
01190 	LDA	#HSIZE		160 BYTES PER SCREEN LINE
01200 	MUL			TIMES NUMBER OF LINES
01210 	ADDB	1,S		ADD IN THE X BYTES
01220 	ADCA	#0		REG.D NOW = 160*Y+X MORE OR LESS
01230 	ADDD	#SCREEN		ADD START OF SCREEN OFFSET
01240 	TFR	D,X		REG.X NOW CONTAINS CORRECT MEMORY BYTE
01250 	LDB	HFCOLR		LOAD PALETTE VALUE; ODD PIXEL
01260 	PULS	CC,A		RECOVER NIBBLE INFO
01270 	LDA	#%11110000	GET EVEN PIXEL MASK; CARRY NOT AFFECTED
01280 	BCS	HSET		PIXEL FORMAT: $EEEEOOOO
01290 	LSLB			SHIFT INTO EVEN PIXEL FORMAT
01300 	LSLB
01310 	LSLB
01320 	LSLB
01330 	COMA			ADJUST PIXEL MASK TO ODD VALUE
01340 HSET	ANDA	,X		CLEAR IN QUESTION PIXEL; KEEP OTHER
01350 	STA	,X
01360 	ORB	,X		ADD IN COLOR
01370 	STB	,X		SET THE SCREEN
01380 	PULS	D,PC
01390 
01400 * THIS IS A FAST MEDIUM GRADE RANDOM NUMBER GENERATOR
01410 * LENGTH OF NON-REPEATING SEQUENCE = 16,777,215
01420 * INTERMEDIATE OUTPUT 0 - 255 OR 0 - .996078431 STEPS OF .003921568
01430 * ENTER: REG.B = N+1
01440 * EXIT:  REG.A = 0 TO N
01450 *        REG.B = FRACTIONAL PART OF N
01460 RAND	LDA	RND+2	GET 19TH BIT
01470 	ANDA	#%00100000
01480 	LSLA		ALIGN IT WITH 24TH BIT
01490 	LSLA		  FASTER THAN SHIFTING TO RIGHT
01500 	LSLA
01510 	ROLA
01520 	EORA	RND+2	XOR BITS 19&24
01530 	LSRA		RESULT TO CARRY
01540 	ROR	RND	FEED RESULT INTO RANDOM NUMBER
01550 	ROR	RND+1		AND SHIFT TO THE RIGHT
01560 	ROR	RND+2
01570 	LDA	RND
01580 	MUL
01590 	RTS
01600 
01610 * ENTER: NUMBER IN REG.B
01620 * EXIT:  REG.B = N + RND(0-4)-N: IF >90 THEN REG.B = REG.B/ 2+RND(0-98)
01630 *        REG.A NOT PRESERVED
01640 GETVAL	PSHS	B	SAVE ENTRY NUMBER
01650 	LDB	#5
01660 	BSR	RAND	GET A RANDOM NUMBER 0 TO 4
01670 	SUBD	WALK	EX. RND(4)- 1.9; VIA 1.9*256=$1"."E6
01680 	ADDA	,S	ADD THE ENTRY VALUE
01690 	STA	,S
01700 	BPL	G1
01710 	PSHS	D	GET ABSOLUTE VALUE; ROUND DOWN
01720 	CLRA
01730 	CLRB
01740 	SUBD	,S++
01750 G1	CMPA	#90	IF <= 90 RETURN WITH VALUE
01760 	BLS	XGETV
01770 	LDB	BACKUP	VALUE POKED FROM BASIC
01780 	BSR	RAND	0<=RND<N
01790 	ADDA	#2	2<=RND<N+2
01800 	PSHS	A	SAVE DIVISOR
01810 	LDA	1,S	RECOVER DIVIDEND
01820 	LDB	#-1	INITIALIZE QUOTIENT
01830 GLOOP	INCB		DIVIDE
01840 	SUBA	,S
01850 	BCC	GLOOP
01860 	LEAS	1,S
01870 	STB	,S
01880 XGETV	PULS	B,PC
01890 
01900 XLOC	RMB	1	DELTA X FROM CENTER
01910 YLOC	RMB	1	DELTA Y FROM CENTER
01920 CNTCLR	RMB	1	COLOR CHANGE COUNTER
01930 
01940 	END	START
